com.tibbo.aggregate.common.plugin

## Interface ContextPlugin

- All Superinterfaces:
    AggreGatePlugin
  All Known Implementing Classes:
    AbstractContextPlugin, DemoServerPlugin

      public interface ContextPlugin
      extends AggreGatePlugin

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deinitialize()` This method is called right before plugin destruction.
    `void` | `deinstall(ContextManager<ServerContext> contextManager)` This method is called before server context tree is destroyed.
    `void` | `deinstall(ServerContext context)` This method is called when a server context is destroyed or removed upon server shutdown.
    `void` | `initialize()` This method is called right after plugin creation.
    `void` | `install(ContextManager<ServerContext> contextManager)` This method is called when server context tree is fully loaded.
    `void` | `install(ServerContext context)` This method is called when a new server context is created or loaded upon server startup.
    `void` | `launch()` This method is called in the very end of server startup.
    `void` | `shutdown()` This method is called in the very beginning of server shutdown.

    - ### Methods inherited from interface com.tibbo.aggregate.common.plugin.AggreGatePlugin

      `createGlobalConfigContext, createUserConfigContext, getDescription, getGlobalConfigContext, getId, getShortId, getSortIndex, getUserConfigContext, globalDeinit, globalInit, globalStart, globalStop, userDeinit, userInit`

- - ### Method Detail

    - #### initialize

          void initialize()
                   throws PluginException

      This method is called right after plugin creation.
      Throws:
        `PluginException`

    - #### deinitialize

          void deinitialize()
                     throws PluginException

      This method is called right before plugin destruction.
      Throws:
        `PluginException`

    - #### install

          void install(ContextManager<ServerContext> contextManager)
                throws ContextException,
                       PluginException

      This method is called when server context tree is fully loaded.
      Parameters:
        `contextManager` - Server context manager
      Throws:
        `ContextException` - If some context API calls from within this method have thrown an exception
        `PluginException` - If plugin internal error occurred

    - #### deinstall

          void deinstall(ContextManager<ServerContext> contextManager)
                  throws ContextException,
                         PluginException

      This method is called before server context tree is destroyed.
      Parameters:
        `contextManager` - Server context manager
      Throws:
        `ContextException` - If some context API calls from within this method have thrown an exception
        `PluginException` - If plugin internal error occurred

    - #### install

          void install(ServerContext context)
                throws ContextException,
                       PluginException

      This method is called when a new server context is created or loaded upon server startup.
      Parameters:
        `context` - Server context
      Throws:
        `ContextException` - If some context API calls from within this method have thrown an exception
        `PluginException` - If plugin internal error occurred

    - #### deinstall

          void deinstall(ServerContext context)
                  throws ContextException,
                         PluginException

      This method is called when a server context is destroyed or removed upon server shutdown.
      Parameters:
        `context` - Server context
      Throws:
        `ContextException` - If some context API calls from within this method have thrown an exception
        `PluginException` - If plugin internal error occurred

    - #### launch

          void launch()
               throws PluginException

      This method is called in the very end of server startup.
      Throws:
        `PluginException` - If plugin internal error occurred

    - #### shutdown

          void shutdown()
                 throws PluginException

      This method is called in the very beginning of server shutdown.
      Throws:
        `PluginException` - If plugin internal error occurred